#include <stdio.h>
#include <stdlib.h>

// Returns whether overflow occured
int factorial(int num, unsigned long long *res);

int main(int argc, char *argv[]) {

	if (argc != 2) {
		printf("USAGE: %s <number>\n", argv[0]);
		return -1;
	}

	int num = atoi(argv[1]);
	if (num < 1) {
		printf("Number must be >1\n");
		printf("USAGE: %s <number>\n", argv[0]);
		return -1;
	}
	unsigned long long res = 0;
	int err = factorial(num, &res);

	printf("Result of factorial(%d) is %llu\n", num, res);
	if (err) {
		printf("However, overflow occured!\n");
	}

    return 0;
}
